using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SceneManagement;
using System.Collections;
using System.Threading.Tasks;

namespace Image
{
    public class Uploader
    {
        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("I-Beam"),
                    NameOverride = "PNG Box",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("Machinery"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<ImageUploaderBehaviour>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Thumb.png");
                        Instance.GetComponent<PhysicalBehaviour>().RefreshOutline();
                        Instance.FixColliders();
                        ImageUploaderBehaviour.wait = ModAPI.LoadSprite("wait.png");
                        ImageUploaderBehaviour.main = ModAPI.LoadSprite("Thumb.png");
                    }
                }
            );
            var ds = ModAPI.FindSpawnable("RGlzY29yZA==");
            if (ds == null)
            {
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "RGlzY29yZA==",
                        DescriptionOverride = "bmVlZCBhIEh1bWFu",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("discordQR.jpg"),
                        AfterSpawn = (Instance) =>
                        {
                            var f = ModAPI.LoadSound("f.wav");
                            foreach (GameObject gameObject in UnityEngine.Object.FindObjectsOfType<GameObject>())
                            {
                                if (gameObject.name == "Human")
                                {
                                    var g = gameObject.AddComponent<AudioSource>();
                                    g.clip = f;
                                    g.Play();
                                }
                            }
                            GameObject.Destroy(Instance);
                        }
                    }
                );
            }
            var yt = ModAPI.FindSpawnable("WW91dHViZQ==");
            if (yt == null)
            {
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "WW91dHViZQ==",
                        DescriptionOverride = "",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("youtubeQR.jpg"),
                        AfterSpawn = (Instance) =>
                        {
                            GameObject.Destroy(Instance);
                        }
                    }
                );
            }
        }
        public class ImageUploaderBehaviour : MonoBehaviour
        {
            public static Sprite wait;
            public static Sprite main;
            private void Start()
            {
                downloadPath = GetModPath() + "/Downloads";
                if (!Directory.Exists(downloadPath))
                {
                    Directory.CreateDirectory(downloadPath);
                }
                gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("changeSprite", "Change sprite", "Changes sprite.", (UnityAction)(() =>
                {
                    DialogBox dialog = (DialogBox)null;
                    dialog = DialogBoxManager.TextEntry("Enter the URL", "URL", new DialogButton("Apply", true, new UnityAction[1]
                    {
                    (UnityAction) (() =>
                    {
                        if(!dialog.EnteredText.Contains(".png"))
                        {
                            ModAPI.Notify("<color=red> YOU CAN ONLY UPLOAD .PNG FILES");
                            return;
                        }
                        if(!dialog.EnteredText.Contains("http") && new FileInfo(dialog.EnteredText).Exists)
                        {
                            gameObject.GetComponent<SpriteRenderer>().sprite = Utils.LoadSprite(dialog.EnteredText, FilterMode.Point);
                            gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
                            gameObject.FixColliders();

                            return;
                        }
                        url = dialog.EnteredText;
                        gameObject.GetComponent<SpriteRenderer>().sprite = Utils.LoadSprite("wait.png", FilterMode.Point);
                        StartCoroutine(StartDownload(url));
                    })
                    }),
                    new DialogButton("Cancel", true, (UnityAction)(() => dialog.Close())));
                })));
                if (url != null && url != "")
                {
                    StartCoroutine(StartDownload(url));
                }
                gameObject.GetComponent<SpriteRenderer>().sprite = main;
                gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
                gameObject.FixColliders();
            }
            private void Update()
            {
                if (downloaded)
                {
                    gameObject.GetComponent<SpriteRenderer>().sprite = wait;
                    gameObject.GetComponent<SpriteRenderer>().sprite = Utils.LoadSprite(imagePath, FilterMode.Point);
                    gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
                    gameObject.FixColliders();
                    downloaded = false;
                    StartCoroutine("Deleter");
                }
            }
            IEnumerator Deleter()
            {
                yield return new WaitForSeconds(1);
                DirectoryInfo di = new DirectoryInfo(downloadPath);
                di.Delete(true);
            }
            private IEnumerator StartDownload(string url)
            {
                gameObject.GetComponent<SpriteRenderer>().sprite = wait;
                imagePath = downloadPath + "/" + new FileInfo(url).Name;
                yield return Download(url, imagePath);
                downloaded = true;
                yield break;
            }
            private async Task<byte[]> Download(string url, string path)
            {
                gameObject.GetComponent<SpriteRenderer>().sprite = wait;
                byte[] bytes = await Utils.HttpDownload(url);
                Stream fileStream = new FileInfo(path).Create();
                fileStream.Write(bytes, 0, bytes.Length);
                return bytes;
            }
            private string GetModPath()
            {
                if (Directory.Exists(Environment.CurrentDirectory + "/" + location))
                {
                    return Environment.CurrentDirectory + "/" + location;
                }
                else
                {
                    return location;
                }
            }

            public string url;
            private bool downloaded;
            public static string location;
            private string downloadPath;
            private string imagePath;
        }
    }
}